var exec = require('child_process').exec;
var fs = require('fs');
// npm install promise --save
var Promise = require('promise');
// npm install node-progress-bars --save
var ProgressBar = require('node-progress-bars');

var results = [];


function readPages(i) {
    var bar = new ProgressBar({
        schema: ':bar.magenta :percent :elapseds :etas'
        // total : 70
    });

    var paths = [
        { url : 'http://www.premierinn.com', method: 'http', type:'desktop'}
        // { url : 'https://www.premierinn.com', method: 'https', type:'desktop'},
        // { url : 'http://m.premierinn.com', method: 'http', type:'mobile'},
        // { url : 'https://m.premierinn.com', method: 'https', type:'mobile'}
    ];


    var iv = setInterval(function () {
        bar.tick(1);
        if (bar.completed) {
            clearInterval(iv);
        }
    }, 5000);

    readPage(paths[i]).then(function(data) {
        if (++i < paths.length) {
            readPages(++i);
        } else {
            console.log('Finished with ' + elem.url);
            printSummary();
        }

    });

}


/**
 * read the page to find the html fil
 * @param path
 */
function readPage(elem) {
    var promise = new Promise( function (resolve, reject) {

        var fileName = elem.method + elem.type + '.txt';

        exec('wget --output-file=' + fileName + ' -r --show-progress --spider --force-html -A ".html" ' + elem.url, function(error, stdout, stderr) {
            console.log('Refactoring ' + elem.url + ' to display visible results');
            transformData(elem);
            resolve('resolved');
        });
    });

    return promise;

}

/**
 * refine the temporal file and create a new one with the important data.
 * @param elem
 */
function transformData(elem) {
    var remaining = '';
    var number = 0;
    var fileName = elem.method + elem.type + '.txt';
    var fileNameResult = elem.method + elem.type + "Result.txt";


    fs.readFile(fileName, 'utf8', function (err,data) {
        if (err) {
            return console.log(err);
        }

        remaining += data;
        var index = remaining.indexOf('\n');
        while (index > -1) {
            var line = remaining.substring(0, index);
            remaining = remaining.substring(index + 1);

            var linea = line.match(/([‘])(?:(?=(\\?))\2.)*?’ saved/);

            if (linea !== null) {
                number++;
                writeNewLineOnFile(fileNameResult, linea[0], number);

            }

            index = remaining.indexOf('\n');
        }
        results.push('we have found ' + number + ' html files for ' + elem.url);
        // Delete temporal file from the spider
        // fs.unlink(fileName);
        var folderName = (elem.url).match(/[^\/\/]*$/);
        deleteFolderRecursive(folderName[0]);
    });

}

/**
 * Write a clean line on the results file
 * @param fileNameResult
 * @param line
 * @param number
 */
function writeNewLineOnFile(fileNameResult, line, number) {

    var newLine = 'Html file ' + number + ' : ' + line.slice(0,-6) + '\r\n';
    fs.appendFile(fileNameResult, newLine, function(err) {

        if(err) {
            return console.log(err);
        }

    });

}

/**
 * Delete folder after finishing the spider
 * @param path
 */
function deleteFolderRecursive(path) {
    if( fs.existsSync(path) ) {
        fs.readdirSync(path).forEach(function(file,index){
            var curPath = path + "/" + file;
            if(fs.lstatSync(curPath).isDirectory()) { // recurse
                deleteFolderRecursive(curPath);
            } else { // delete file
                fs.unlinkSync(curPath);
            }
        });
        fs.rmdirSync(path);
    }
};

/**
 * Print the results summary.
 */
function printSummary(){
    for (var i = 0; i < results.length; i++) {

        console.log(results[i] )

    }
}

readPages(0);


